'use strict'

const loadShadowScript = (libs: string[], path = '') => {
  let task: Promise<{}>[] = []
  let codeMap = {}
  let code = ''

  for (let url of libs) {
    task.push(new Promise((resolve, reject) => {
      fetch(path + url).then((response) => {
        return response.text()
      }).then((text) => {
        codeMap[url] = text
        resolve()
      }).catch(() => {
        console.log('load ' + url + ' failed!')
        reject()
      })
    }))
  }

  return new Promise((resolve, reject) => {
    Promise.all(task).then(() => {
      for (let url of libs) {
        code += '; \n' + codeMap[url] + '; \n'
      }
      resolve(code)
    }).catch(() => {
      reject()
    })
  })
}

export {
  loadShadowScript
}
